require "agent_jones/version"
require "thor"
require 'pathname'

module AgentJones
 	class CLI < ::Thor

 		option :repo, :required => true
	 	option :password
		option :temp_dir
		option :keychain, :required => true


		desc "import", "import certificates from a repository"
		def import

			passwords = {}
			options[:password].split(',').each do |element| 
				components = element.split('=')

				if components.count == 1
					passwords['/'] = components.first
				elsif components.count == 2
					passwords[components.first] = components.last
				end
			end

			passwords['/'] ||= ''

			Dir.chdir (options[:temp_dir] || Dir.mktmpdir) do
				
				system "git clone #{options[:repo]} repo &> /dev/null"

				certificates = Dir["repo/**/**.{p12,cer}"]
				puts "#{certificates.count} certificates found"

				certificates.each do |certificate|
		
					puts "installing #{certificate}..."
					path = "/" + Pathname(certificate).each_filename.to_a[1..-2].join('/')
					password =  passwords[path] || passwords['/']

					cmd = "security import #{certificate} -k #{options[:keychain]} -T /usr/bin/codesign"
					cmd += " -P #{password}" if password.length > 0

					system(cmd)
				end
			end

		end

 	end
end
